package fr.aminelouveaau.cartes.model;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;

import java.util.Objects;

public class Card {
    private final Shape shape;
    private final Number number;

    @JsonCreator
    public Card(@JsonProperty("shape") Shape shape, @JsonProperty("number") Number number) {
        this.shape = shape;
        this.number = number;
    }

    public Shape getShape() {
        return shape;
    }

    public Number getNumber() {
        return number;
    }

    @Override
    public String toString() {
        return number + " of " + shape;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Card card = (Card) o;
        return getShape() == card.getShape() && getNumber() == card.getNumber();
    }

    @Override
    public int hashCode() {
        return Objects.hash(getShape(), getNumber());
    }
}
